<?php
/**
 * @version
 * @package Joomla
 * @subpackage p8Twitter
 * @copyright Copyright (C) 2009 Rob Clayburn. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );
jimport( 'joomla.application.component.model' );

/**
 * @package		Joomla
 * @subpackage	Fabble
 */

class p8TwitterControllerHome extends JController
{

	/**
	 * Constructor
	 */
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		// Register Extra tasks
    $this->registerTask( 'add',			'edit' );
    $this->registerTask( 'apply',		'save' );
    $this->registerTask( 'unpublish',	'publish' );
	}
	
	/**
	 * Edit a group
	 */

	function edit()
	{
		
		$user =& JFactory::getUser();
		$db =& JFactory::getDBO();
		$row =& JTable::getInstance( 'list', 'Table' );
		if ($this->_task == 'edit') {
			$cid	= JRequest::getVar( 'cid', array(0), 'method', 'array' );
			$cid	= array((int) $cid[0]);
		} else {
			$cid	= array( 0 );
		}
		$row->load( $cid[0] );

		if ($cid) {
			$row->checkout( $user->get( 'id' ) );
		}
		$form = new JParameter( '', JPATH_COMPONENT.DS.'models'.DS.'list.xml' );
		$form->bind( $row );
		
		// Advanced Group
		$form->loadINI($row->attribs);
		
		require_once(JPATH_COMPONENT.DS.'views'.DS.'home.php');
		p8TwitterViewHome::edit( $row, $form );
	}

	function display()
	{
	  global $mainframe;
		$db =& JFactory::getDBO();

		$lists = array();
		// get the total number of records
		$db->setQuery( "SELECT count(*) FROM #__p8twitter_lists" );
		$total = $db->loadResult();
		$context			= 'com_p8twitter.list.list.';
		$filter_order			= $mainframe->getUserStateFromRequest( $context.'filter_order',		'filter_order',	'a.title',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',			'word' );
		
		
		$limit						= $mainframe->getUserStateFromRequest( $context.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart 			= $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );
		$selView   		= $mainframe->getUserStateFromRequest(  $context."view", 'view', '' );
		
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		
		
		$where = array();
		if ($selView != '') {
			$where[] = " view  = $selView ";
		}
		$where		= count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '';
		$orderby	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;
		
		$sql = "SELECT * FROM #__p8twitter_lists ";
		$db->setQuery( $sql, $limitstart, $limit );
		
		$rows = $db->loadObjectList();
		
		//get list of application types
		$db->setQuery( "SELECT DISTINCT(id) AS value, twitter_view AS text FROM #__p8twitter_lists" );
		$l = $db->loadObjectList();
		if (is_array( $l )) {
		  $views =  array_merge( array(JHTML::_('select.option', '', '- ' . JText::_( 'SELECT VIEW TYPE') . ' -' )), $l );
		} else {
		  $views = array(JHTML::_('select.option', '', '- ' . JText::_( 'SELECT VIEW TYPE') . ' -' ));
		}
		$lists['apptypes'] = JHTML::_('select.genericlist',  $views, 'view', 'class="inputbox" onchange="document.adminForm.submit( );"', 'value', 'text', $selView );
		
		
		jimport( 'joomla.html.pagination' );
		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		require_once(JPATH_COMPONENT.DS.'views'.DS.'home.php');
		p8TwitterViewHome::show( $rows, $pageNav, $lists );
	}
	
  /**
   * cancel editing
   */

  function cancel()
  {
    JRequest::checkToken() or die( 'Invalid Token' );
    $row 		=& JTable::getInstance('list', 'Table');
    $id 		= JRequest::getInt( 'id', 0, 'post' );
    $row->load($id);
    $row->checkin();
    $this->setRedirect( 'index.php?option=com_p8Twitter&c=home' );
  }
  
 /**
   * copy a list
   * @param int id
   */

  function copy()
  {
    // Check for request forgeries
    JRequest::checkToken() or die( 'Invalid Token' );

    $this->setRedirect( 'index.php?option=com_p8Twitter&c=home' );

    $cid		= JRequest::getVar( 'cid', null, 'post', 'array' );
    $db			=& JFactory::getDBO();
    $rule		=& JTable::getInstance( 'list', 'Table' );

    $user		= &JFactory::getUser();
    $n			= count( $cid );

    if ($n > 0)
    {
      foreach ($cid as $id)
      {
        if ($rule->load( (int)$id ))
        {
          $rule->id				= 0;
          $rule->name	= 'Copy of ' . $rule->name;
          if (!$rule->store()) {
            return JError::raiseWarning( $rule->getError() );
          }
        }
        else {
          return JError::raiseWarning( 500, $rule->getError() );
        }
      }
    }
    else {
      return JError::raiseWarning( 500, JText::_( 'NO ITEMS SELECTED' ) );
    }
    $this->setMessage( JText::sprintf( 'Items copied', $n ) );
  }
  
  /**
   * Publish a element
   */

  function publish()
  {
    // Check for request forgeries
    JRequest::checkToken() or die( 'Invalid Token' );

    $this->setRedirect( 'index.php?option=com_p8Twitter&c=home' );

    // Initialize variables
    $db			=& JFactory::getDBO();
    $user		=& JFactory::getUser();
    $cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
    $task		= JRequest::getCmd( 'task' );
    $publish	= ($task == 'publish');
    $n			= count( $cid );

    if (empty( $cid )) {
      return JError::raiseWarning( 500, JText::_( 'NO ITEMS SELECTED' ) );
    }

    JArrayHelper::toInteger( $cid );
    $cids = implode( ',', $cid );

    $query = 'UPDATE #__p8twitter_lists'
    . ' SET state = ' . (int) $publish
    . ' WHERE id IN ( '. $cids.'  )'
    . ' AND ( checked_out = 0 OR ( checked_out = ' .(int) $user->get('id'). ' ) )'
    ;
    $db->setQuery( $query );
    if (!$db->query()) {
      return JError::raiseWarning( 500, $row->getError() );
    }
    $this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );
  }
  
  /**
   * delete list
   */

  function remove()
  {
    // Check for request forgeries
    JRequest::checkToken() or die( 'Invalid Token' );

    $this->setRedirect( 'index.php?option=com_p8Twitter&c=home' );

    // Initialize variables
    $db		=& JFactory::getDBO();
    $cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
    $n		= count( $cid );
    JArrayHelper::toInteger( $cid );

    if ($n)
    {
      $query = 'DELETE FROM #__p8twitter_lists'
      . ' WHERE id = ' . implode( ' OR id = ', $cid )
      ;
      $db->setQuery( $query );
      if (!$db->query()) {
        JError::raiseWarning( 500, $db->getError() );
      }
    }
    $this->setMessage( JText::sprintf( 'Items removed', $n ) );
  }
  
	/**
	 * Save method
	 */
	function save()
	{
		global $mainframe;
    $task = JRequest::getVar('task');
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_p8Twitter&c=home' );

		// Initialize variables
		$db =& JFactory::getDBO();

		$post	= JRequest::get( 'post' );
    $details			= JRequest::getVar( 'details', array(), 'post', 'array' );
    
		$row =& JTable::getInstance('list', 'Table');

		if (!$row->bind( $post )) {
			return JError::raiseWarning( 500, $row->getError() );
		}
    
		if (!$row->check()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
    $row->bind( $details );  
    
	  $params		= JRequest::getVar( 'params', null, 'post', 'array' );

		// Build parameter INI string
		if (is_array($params))
		{
			$txt = array ();
			foreach ($params as $k => $v) {
				$txt[] = "$k=$v";
			}
			$row->attribs = implode("\n", $txt);
		}
		
		if (!$row->store()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		$row->checkin();
		switch ($task)
		{
			case 'apply':
				$link = 'index.php?option=com_p8Twitter&task=edit&cid[]='. $row->id ;
				break;

			case 'save':
			default:
				$link = 'index.php?option=com_p8Twitter';
				break;
		}

		$this->setRedirect( $link, JText::_( 'Item Saved' ) );
	}
	

}
?>